; ********************************************************************
;                           MW.LSP
;        ,
;  ,       2    2.
;    ,       .
;  Copyright (C)  ..                       4a  6/05/97
; ********************************************************************
(defun mwerr (S)
   (if (/= S "Function cancelled")   ; If an error (such as CTRL-C) occurs
      (princ (strcat "\nError: " S)) ; while this command is active...
   )
   (setq S nil)                      ; Free selection set
   (setq *error* OLDERR)             ; Restore old *error* handler
   (princ)
)
(defun MODIFY_WIDTH (W / TMP TMP1 S S1 N I NE R D CPOINT LAY COL)
 (setq S (ssget "X" '((8 . "2"))))
 (setq S1 (ssget "X" '((62 . 2))))
 (if (or (not (not S)) (not (not S1)))
  (progn
  (if (not (not S1))
   (progn
    (setq N (sslength S1))
    (if (not S)
     (setq S (ssadd))
    )
    (setq I 0)
    (while (< I N)
     (setq S (ssadd (ssname S1 I) S))
     (setq I (1+ I))
    )
   )
  )
 (setq I 0)
 (setq N (sslength S))
 (while (< I N)
   (setq NE (cdr (assoc 0 (setq TMP1 (entget (ssname S I))))))
   (setq LAY (cdr (assoc 8 TMP1)))
   (setq COL (cdr (assoc 62 TMP1)))
   (setq TMP (ssname S I))
  (cond
   ((= NE "POLYLINE") (command "_PEDIT" TMP "_Width" W "_x"))
   ((= NE "LINE") (command "_PEDIT" TMP  "_Y" "_Width" W "_x"))
   ((= NE "ARC") (command "_PEDIT" TMP  "_Y" "_Width" W "_x"))
   ((= NE "CIRCLE")
   (progn
        (setq R (cdr (assoc 40 tmp1)))
        (setq CPOINT (cdr (assoc 10 TMP1)))
        (command "_ERASE" TMP "")
        (setq D (* 2 R))
        (if (not (not LAY))
         (command "_LAYER" "_S" LAY "")
        )
        (if (not (not COL))
         (command "_COLOR" COL)
        )
        (command "_DONUT" (if (< D W) 0 (- D W)) (+ D W) CPOINT "")
   ))
  )
  (setq I (1+ I))
  (princ ".")
 )
 );end progn
 );end if
)
(defun C:MW (/ OCMD W CL CC TMP FLAG BL NB)
   (setq OLDERR  *error*             ; Initialize variables
         *error* mwerr
         OCMD (getvar "CMDECHO")
         CL (getvar "CLAYER")
         CC (getvar "CECOLOR")
   )
   (setvar "CMDECHO" 0)
   (command "_LIMITS" "_OFF")
   (setq W 0.5)
   (initget 4)
   (setq TMP (getreal (strcat "\nT  < " (rtos W) " >: ")))
   (if (/= TMP nil) (setq W TMP))
   (command "_ZOOM" "_E")
   (setq EMIN (getvar "EXTMIN") EMAX (getvar "EXTMAX"))
   (if (tblsearch "BLOCK" "$W")
    (command "_BLOCK" "$W" "_Y" (list 0 0) "_C" EMIN EMAX "")
    (command "_BLOCK" "$W" (list 0 0) "_C" EMIN EMAX "")
   )
   (setq FLAG T)
   (while (setq TMP (tblnext "BLOCK" FLAG))
    (setq BL (cons (cdr (assoc 2 TMP)) BL))
    (setq FLAG nil)
   )
   (while (setq NB (car BL))
    (if (/= (substr NB 1 1) "*")
     (progn
      (command "_INSERT" (strcat "*" NB) (list 0 0) 1 0)
      (modify_width W)
      (command "_ZOOM" "_E")
      (setq EMIN (getvar "EXTMIN") EMAX (getvar "EXTMAX"))
      (command "_BLOCK" NB "_Y" (list 0 0) "_C" EMIN EMAX "")
     )
    )
    (setq BL (cdr BL))
   )
   (command "_INSERT" (strcat "*" "$W") (list 0 0) 1 0)
   (command "_LAYER" "_S" CL "")
   (command "_COLOR" CC)
   (command "_ZOOM" "_E")
   (command "_LIMITS" "_ON")
   (setvar "CMDECHO" ocmd)            ; Restore saved mode
   (setq *error* olderr)             ; Restore old *error* handler
   (princ)
)
